﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text

Module Module1
    Sub Main(ByVal args() As String)
        Try
            Console.WriteLine(vbLf & "Begin Diffusion Testing demo" & vbLf)
            Console.WriteLine("Method under test: Choose(n,k)" & vbLf)
            'Dim eightChooseThree = Choose(8, 3)
            'Console.WriteLine(eightChooseThree)
            Dim testCases() = {"001:8:3:56", "002:7:5:20", "003:9:2:36"}
            For Each currTestCase In testCases
                Dim result = ProcessTestCase(currTestCase)
                If result = "pass" Then
                    Console.WriteLine("Automatically creating new test case")
                    Dim newTestCase = CreateDiffusedTestCase(currTestCase)
                    'Console.WriteLine("diff tc = " & diffusedTestCase)
                    ProcessTestCase(newTestCase)
                End If
            Next currTestCase
            Console.WriteLine("===========================")
            Console.WriteLine(vbLf & "End demo" & vbLf)
            Console.ReadLine()
        Catch ex As Exception
            Console.WriteLine("Fatal: " & ex.Message)
            Console.ReadLine()
        End Try
    End Sub ' Main()

    Private Function Choose(ByVal n As Integer, ByVal k As Integer) As Long
        Dim delta, iMax As Long
        If k < n - k Then
            delta = n - k
            iMax = k
        Else
            delta = k
            iMax = n - k
        End If
        Dim answer = delta + 1
        For i = 2 To iMax
            answer = (answer * (delta + i)) / i
        Next i
        Return answer
    End Function

    Private Function ProcessTestCase(ByVal testCase As String) As String
        Dim tokens() = testCase.Split(":"c)
        Dim caseID = tokens(0)
        Dim n = Integer.Parse(tokens(1))
        Dim k = Integer.Parse(tokens(2))
        Dim expected = Long.Parse(tokens(3))
        Console.WriteLine("===========================")
        Console.WriteLine("Case ID = " & caseID)
        Console.WriteLine("n = " & n & " k = " & k)
        Console.Write("Expected result = " & expected)
        Dim actual = Choose(n, k)
        Console.WriteLine(" Actual = " & actual)
        If actual = expected Then
            Console.WriteLine("Pass")
            Return "pass"
        Else
            Console.WriteLine("** Fail ** ")
            Return "fail"
        End If
    End Function

    Private Function CreateDiffusedTestCase(ByVal existingTestCase As String) As String
        Dim tokens() = existingTestCase.Split(":"c)
        Dim oldTestCase = tokens(0)
        Dim oldN = Integer.Parse(tokens(1))
        Dim oldK = Integer.Parse(tokens(2))
        Dim oldExpected = Long.Parse(tokens(3))
        Dim newTestCase = oldTestCase & "-diffused"
        Dim newN = oldN + 1
        Dim newK = oldK
        'Dim newExpected = oldExpected * ((oldN + 1) / (oldN - oldK + 1))
        Dim newExpected = (oldExpected * (oldN + 1)) / (oldN - oldK + 1)
        'Console.WriteLine("new expected = " & newExpected)
        Return newTestCase & ":" & newN & ":" & newK & ":" & newExpected
    End Function
End Module ' Program
